C         CALCULATE STRESS AND DISPLACEMENT
C    FOR TWO DIMENSIONAL FINIFTE ELEMENT SOLUTION 
C         ------- F3DSD.FOR (1997/7) -------
C                 BY TAKAYUKI HIRAI 
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/RN22(20),H22(3,20),XYZ(3,20),BMA(6,60),
     1         DF(60),EE(6,6,30),SR(6),XGX(5),EM(500),
     2         STI(8000),PR(500),X1,X2,X3,U1,U2,U3,DET,
     3         GZ,EA,ZE,M,MM,LX,LY,LZ,IDE,IRR
      COMMON/B/CO(8000,3),DU(3,8000),X(20000),
     1         MVE(21,8000),MOU(8000,2)
      CHARACTER TITLE*40,C1*10
C
C  ------------------  INPUT DATA  --------------------
      OPEN(5,FILE='R1',STATUS='OLD')
      OPEN(16,FILE='SD')
      CLOSE(16,STATUS='DELETE')
      OPEN(16,FILE='SD')
      IRR=0
      DO 10 I=1,5
   10 READ(5,1009) C1
      READ(5,1001) TITLE 
      WRITE(*,2001) TITLE
      WRITE(16,2002) TITLE
      READ(5,1009) C1
      READ(5,1009) C1
      READ(5,1002) NELE,NODE,NMAT
      WRITE(16,2003) NELE,NODE,NMAT
      READ(5,1009) C1
      READ(5,1009) C1
      DO 11 I=1,NODE 
   11 READ(5,1003) NS,X(I*3-2),X(I*3-1),X(I*3) 
      READ(5,1009) C1
      READ(5,1009) C1
      DO 16 J=1,NMAT
      READ(5,1006) II,EM(J),PR(J)
      IF(EM(J).LE.1.0) IRR=5
      IF(PR(J)*(0.4999-PR(J)).LT.0) IRR=5
      DO 17 II=1,6
      DO 17 JK=1,6
   17 EE(II,JK,J)=0.0
      EE(6,6,J)=EM(J)/(1.0+PR(J))
      EE(1,1,J)=EE(6,6,J)*(1.0-PR(J))/(1.0-2.0*PR(J))
      EE(1,2,J)=EE(6,6,J)*PR(J)/(1.0-2.0*PR(J))
      EE(6,6,J)=0.5*EE(6,6,J)
      EE(5,5,J)=EE(6,6,J)
      EE(4,4,J)=EE(6,6,J)
      DO 16 I=1,3 
      DO 16 K=1,3   
      IF(I.EQ.K) EE(I,K,J)=EE(1,1,J)
   16 IF(I.NE.K) EE(I,K,J)=EE(1,2,J)
      READ(5,1009) C1
      READ(5,1009) C1
      READ(5,1009) C1
      DO 23 J=1,NELE
   23 READ(5,1007) MS,(MVE(I,J),I=1,21),STI(J),SVOL
      READ(5,1009) C1
      READ(5,1009) C1
      READ(5,1009) C1
      DO 25 N=1,NODE
   25 READ(5,1008) DU(1,N),DU(2,N),DU(3,N)
 1001 FORMAT(A40) 
 1002 FORMAT(12X,I5,18X,I5,16X,I3)
 1003 FORMAT(I5,3F15.6)
 1006 FORMAT(I9,F20.6,F15.6)     
 1007 FORMAT(I4,I6,19I4,I5,F12.7,F12.4)
 1008 FORMAT(55X,3E16.7)
 1009 FORMAT(A10)
 2001 FORMAT(/' START  ',A40)
 2002 FORMAT(//A40)
 2003 FORMAT('  ELEMENTS =',I5,'    NODES =',I5,
     1    '    MATERIALS =',I3)
C
C  -------  CALCULATE STRESS AND DISPLACEMENT  ------
      CLOSE(5,STATUS='KEEP')
      OPEN(7,FILE='D1',STATUS='OLD')
      MOU(1,1)=0
      NS=1
   40 READ(7,1010,END=41) MOU(NS,1),MOU(NS,2),
     1    CO(NS,1),CO(NS,2),CO(NS,3)
      IF(MOU(NS,1).EQ.99999) GOTO 41
      NS=NS+1
      GO TO 40
 1010 FORMAT(2I5,3F10.5)
   41 NS=NS-1
      IF(NS.GT.2000) IRR=8
      DO 42 I2=1,NS
      N1=MOU(I2,1)
      N2=MOU(I2,2)
      IF(N1.LE.0) IRR=9
      IF(N1.GT.NELE) IRR=9
      IF(IRR.NE.0) GO TO 43
      IF(N2.LT.7000) GO TO 44
      M=N1
      MM=MVE(21,M)
      DO 46 II=1,20
      DF(3*II-2)=DU(1,MVE(II,N1))
      DF(3*II-1)=DU(2,MVE(II,N1))
   46 DF(3*II)=DU(3,MVE(II,N1))
      DO 47 II=1,20
      DO 47 JJ=1,3
   47 XYZ(JJ,II)=X(MVE(II,N1)*3-3+JJ)
      IF(N2.LT.8000) GO TO 32
      IF(N2.LT.9000) GO TO 48
      GZ=CO(I2,1)
      EA=CO(I2,2)
      ZE=CO(I2,3)
      WRITE(16,2013) GZ,EA,ZE
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 31
      WRITE(16,2020)
      WRITE(16,2032) N1,X1,X2,X3,U1,U2,U3
      GO TO 42
   31 WRITE(16,2031) N1,X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
      GO TO 42
 2026 FORMAT(1H ,I4,3F10.5,3E13.5,6F10.3)
 2027 FORMAT(1H ,I4,3F10.5,3E13.5)
 2018 FORMAT(1H ,'    ---- ZERO DETERMINANT JACOBIAN ',
     1    '----       GZ-EA-ZE =',3F11.5)
 2013 FORMAT(/' ELEMENT   COODINATE X-Y-Z   DIPLACEMEN'
     1    ,'T X-Y-Z   STRESS X-Y-Z-XY-YZ-ZX   ( GZ-EA-'
     2    ,'ZE =',3F11.5,' )')
 2020 FORMAT(1H ,'    ---- ZERO DETERMINANT JACOBIAN ',
     1    '----')
 2016 FORMAT(1H ,3F10.5,3E13.5,6F10.3)
 2017 FORMAT(1H ,3F10.5,3E13.5)
 2031 FORMAT(1H ,I5,3F10.5,3E13.5,6F10.3)
 2032 FORMAT(1H ,I5,3F10.5,3E13.5)
   48 IF(N2.EQ.8101) GO TO 54
      IF(N2.EQ.8110) GO TO 55
      EA=CO(I2,2)
      ZE=CO(I2,3)
      WRITE(16,2035) N1,N2,EA,ZE
      DO 56 LX=1,5
      GZ=FLOAT(LX-3)*0.5
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 61
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 56
   61 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   56 CONTINUE 
      GO TO 42
   54 GZ=CO(I2,1)
      ZE=CO(I2,3)
      WRITE(16,2036) N1,N2,GZ,ZE
      DO 57 LY=1,5
      EA=FLOAT(LY-3)*0.5
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 62
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 57
   62 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   57 CONTINUE 
      GO TO 42
   55 GZ=CO(I2,1)
      EA=CO(I2,2)
      WRITE(16,2037) N1,N2,GZ,EA
      DO 58 LZ=1,5
      ZE=FLOAT(LZ-3)*0.5
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 63
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 58
   63 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   58 CONTINUE 
      GO TO 42
 2015 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I6,
     1    '  GZ-EA-ZE =',3F12.5/5X,' COODINATE X-Y-Z',
     2    14X,'DISPLACEMENT X-Y-Z',24X,'STRESS X-Y-Z',
     3    '-XY-YZ-ZX')
 2035 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,
     1    '  EA =',F12.5,'  ZE =',F12.5/5X,
     2    ' COODINATE X-Y-Z',14X,'DISPLACEMENT X-Y-Z'
     3    ,24X,'STRESS X-Y-Z-XY-YZ-ZX')
 2036 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,
     1    '  GZ =',F12.5,'  ZE =',F12.5/5X,
     2    ' COODINATE X-Y-Z',14X,'DISPLACEMENT X-Y-Z'
     3    ,24X,'STRESS X-Y-Z-XY-YZ-ZX')
 2037 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,
     1    '  GZ =',F12.5,'  EA =',F12.5/5X,
     2    ' COODINATE X-Y-Z',14X,'DISPLACEMENT X-Y-Z'
     3    ,24X,'STRESS X-Y-Z-XY-YZ-ZX')
   32 IF(N2.EQ.7001) GO TO 49
      IF(N2.EQ.7010) GO TO 50
      GZ=CO(I2,1)
      WRITE(16,2038) N1,N2,GZ
      DO 51 LY=1,3
      EA=FLOAT(LY-2)
      DO 51 LZ=1,3
      ZE=FLOAT(LZ-2)
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 64
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 51
   64 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   51 CONTINUE 
      GO TO 42
   50 EA=CO(I2,2)
      WRITE(16,2039) N1,N2,EA
      DO 52 LX=1,3
      GZ=FLOAT(LX-2)    
      DO 52 LZ=1,3
      ZE=FLOAT(LZ-2)    
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 65
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 52
   65 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   52 CONTINUE 
      GO TO 42
   49 ZE=CO(I2,3)
      WRITE(16,2040) N1,N2,ZE
      DO 53 LX=1,3
      GZ=FLOAT(LX-2)    
      DO 53 LY=1,3
      EA=FLOAT(LY-2)    
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 66
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 53
   66 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   53 CONTINUE 
      GO TO 42
 2038 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,' ',
     1   ' GZ =',F12.5/5X,' COODINATE X-Y-Z',14X,'DIS',
     2   'PLACEMENT X-Y-Z',24X,'STRESS X-Y-Z-XY-YZ-ZX')
 2039 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,' ',
     1   ' EA =',F12.5/5X,' COODINATE X-Y-Z',14X,'DIS',
     2   'PLACEMENT X-Y-Z',24X,'STRESS X-Y-Z-XY-YZ-ZX')
 2040 FORMAT(/' ELEMENT =',I5,'  APPOINTMENT =',I5,' ',
     1   ' ZE =',F12.5/5X,' COODINATE X-Y-Z',14X,'DIS',
     2   'PLACEMENT X-Y-Z',24X,'STRESS X-Y-Z-XY-YZ-ZX')
   44 IF(N2.LT.N1) IRR=9
      IF(IRR.NE.0) GO TO 43
      DO 35 M=N1,N2
      MM=MVE(21,M)
      WRITE(16,2019) M
      DO 33 II=1,20
      DF(3*II-2)=DU(1,MVE(II,M))
      DF(3*II-1)=DU(2,MVE(II,M))
   33 DF(3*II)=DU(3,MVE(II,M))
      DO 36 II=1,20
      DO 36 JJ=1,3
   36 XYZ(JJ,II)=X(MVE(II,M)*3-3+JJ)
      DO 34 LX=1,3
      GZ=FLOAT(LX-2)
      DO 34 LY=1,3
      EA=FLOAT(LY-2)
      DO 34 LZ=1,3
      ZE=FLOAT(LZ-2)
      IDE=0
      CALL TTT
      IF(IDE.EQ.0) GO TO 67
      WRITE(16,2018) GZ,EA,ZE
      WRITE(16,2017) X1,X2,X3,U1,U2,U3
      GO TO 34
   67 WRITE(16,2016) X1,X2,X3,U1,U2,U3,(SR(I),I=1,6)
   34 CONTINUE
   35 CONTINUE
   42 CONTINUE
   43 IF(IRR.EQ.5) WRITE(16,2055)
      IF(IRR.EQ.8) WRITE(16,2058)
      IF(IRR.EQ.9) WRITE(16,2059)
      IF(IRR.NE.0) WRITE(16,2051)
 2051 FORMAT(/1H ,'   ERROR : DATA IN FILE D1')
 2055 FORMAT(/1H ,'   ERROR : YOUNG MO. OR POASON RA. IN FILE R1  ')
 2058 FORMAT(/1H ,'   ERROR : DATA OVER IN FILE D1 ')
 2059 FORMAT(/1H ,'   ERROR : ELEMENT NUMBER IN FILE D1 ')
 2019 FORMAT(/' ELEMENT =',I6/5X,' COODINATE X-Y-Z',14X,
     1    'DISPLACEMENT X-Y-Z',24X,'STRESS X-Y-Z-XY-YZ'
     2    ,'-ZX')
      CLOSE(16,STATUS='KEEP')
      CLOSE(7,STATUS='KEEP')
      STOP
      END
      SUBROUTINE TTT
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/RN22(20),H22(3,20),XYZ(3,20),BMA(6,60),
     1         DF(60),EE(6,6,30),SR(6),XGX(5),EM(500),
     2         STI(8000),PR(500),X1,X2,X3,U1,U2,U3,DET,
     3         GZ,EA,ZE,M,MM,LX,LY,LZ,IDE,IRR
      DIMENSION DE(6)
      CALL GGG
      CALL FFF
      DO 602 I=1,6
      DE(I)=0.0
      DO 602 J=1,60
  602 DE(I)=DE(I)+BMA(I,J)*DF(J)
      DO 603 I=1,6
      SR(I)=0.0
      DO 603 J=1,6
  603 SR(I)=SR(I)+EE(I,J,MM)*DE(J)
      S4=STI(M)*EM(MM)/(1.0-2.0*PR(MM))
      SR(1)=SR(1)-S4
      SR(2)=SR(2)-S4
      SR(3)=SR(3)-S4
      X1=0.0
      X2=0.0
      X3=0.0
      U1=0.0
      U2=0.0
      U3=0.0
      DO 604 I=1,20
      X1=X1+RN22(I)*XYZ(1,I)
      X2=X2+RN22(I)*XYZ(2,I)
      X3=X3+RN22(I)*XYZ(3,I)
      U1=U1+RN22(I)*DF(3*I-2)
      U2=U2+RN22(I)*DF(3*I-1)
  604 U3=U3+RN22(I)*DF(3*I)
      RETURN
      END 
      SUBROUTINE GGG
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/RN22(20),H22(3,20),XYZ(3,20),BMA(6,60),
     1         DF(60),EE(6,6,30),SR(6),XGX(5),EM(500),
     2         STI(8000),PR(500),X1,X2,X3,U1,U2,U3,DET,
     3         GZ,EA,ZE,M,MM,LX,LY,LZ,IDE,IRR
      GZP=1.0+GZ
      EAP=1.0+EA
      ZEP=1.0+ZE
      GZM=1.0-GZ
      EAM=1.0-EA
      ZEM=1.0-ZE
      GZ2=1.0-GZ*GZ
      EA2=1.0-EA*EA
      ZE2=1.0-ZE*ZE
      RN22(1)=GZM*EAM*ZEM*(-GZ-EA-ZE-2.0)/8.0
      RN22(2)=GZP*EAM*ZEM*( GZ-EA-ZE-2.0)/8.0
      RN22(3)=GZP*EAP*ZEM*( GZ+EA-ZE-2.0)/8.0
      RN22(4)=GZM*EAP*ZEM*(-GZ+EA-ZE-2.0)/8.0
      RN22(5)=GZM*EAM*ZEP*(-GZ-EA+ZE-2.0)/8.0
      RN22(6)=GZP*EAM*ZEP*( GZ-EA+ZE-2.0)/8.0
      RN22(7)=GZP*EAP*ZEP*( GZ+EA+ZE-2.0)/8.0
      RN22(8)=GZM*EAP*ZEP*(-GZ+EA+ZE-2.0)/8.0
      RN22( 9)=GZ2*EAM*ZEM/4.0
      RN22(10)=GZP*EA2*ZEM/4.0
      RN22(11)=GZ2*EAP*ZEM/4.0
      RN22(12)=GZM*EA2*ZEM/4.0
      RN22(13)=GZM*EAM*ZE2/4.0
      RN22(14)=GZP*EAM*ZE2/4.0
      RN22(15)=GZP*EAP*ZE2/4.0
      RN22(16)=GZM*EAP*ZE2/4.0
      RN22(17)=GZ2*EAM*ZEP/4.0
      RN22(18)=GZP*EA2*ZEP/4.0
      RN22(19)=GZ2*EAP*ZEP/4.0
      RN22(20)=GZM*EA2*ZEP/4.0
      H22(1,1)=-EAM*ZEM*(-2.0*GZ-EA-ZE-1.0)/8.0
      H22(1,2)=EAM*ZEM*(2.0*GZ-EA-ZE-1.0)/8.0
      H22(1,3)=EAP*ZEM*(2.0*GZ+EA-ZE-1.0)/8.0
      H22(1,4)=-EAP*ZEM*(-2.0*GZ+EA-ZE-1.0)/8.0
      H22(1,5)=-EAM*ZEP*(-2.0*GZ-EA+ZE-1.0)/8.0
      H22(1,6)=EAM*ZEP*(2.0*GZ-EA+ZE-1.0)/8.0
      H22(1,7)=EAP*ZEP*(2.0*GZ+EA+ZE-1.0)/8.0
      H22(1,8)=-EAP*ZEP*(-2.0*GZ+EA+ZE-1.0)/8.0
      H22(1, 9)=-0.5*GZ*EAM*ZEM
      H22(1,10)=EA2*ZEM/4.0
      H22(1,11)=-0.5*GZ*EAP*ZEM
      H22(1,12)=-EA2*ZEM/4.0
      H22(1,13)=-EAM*ZE2/4.0
      H22(1,14)=EAM*ZE2/4.0
      H22(1,15)=EAP*ZE2/4.0
      H22(1,16)=-EAP*ZE2/4.0
      H22(1,17)=-0.5*GZ*EAM*ZEP
      H22(1,18)=EA2*ZEP/4.0
      H22(1,19)=-0.5*GZ*EAP*ZEP
      H22(1,20)=-EA2*ZEP/4.0
      H22(2,1)=-GZM*ZEM*(-GZ-2.0*EA-ZE-1.0)/8.0
      H22(2,2)=-GZP*ZEM*(GZ-2.0*EA-ZE-1.0)/8.0
      H22(2,3)=GZP*ZEM*(GZ+2.0*EA-ZE-1.0)/8.0
      H22(2,4)=GZM*ZEM*(-GZ+2.0*EA-ZE-1.0)/8.0
      H22(2,5)=-GZM*ZEP*(-GZ-2.0*EA+ZE-1.0)/8.0
      H22(2,6)=-GZP*ZEP*(GZ-2.0*EA+ZE-1.0)/8.0
      H22(2,7)=GZP*ZEP*(GZ+2.0*EA+ZE-1.0)/8.0
      H22(2,8)=GZM*ZEP*(-GZ+2.0*EA+ZE-1.0)/8.0
      H22(2, 9)=-GZ2*ZEM/4.0
      H22(2,10)=-0.5*GZP*EA*ZEM
      H22(2,11)=GZ2*ZEM/4.0
      H22(2,12)=-0.5*GZM*EA*ZEM
      H22(2,13)=-GZM*ZE2/4.0
      H22(2,14)=-GZP*ZE2/4.0
      H22(2,15)=GZP*ZE2/4.0
      H22(2,16)=GZM*ZE2/4.0
      H22(2,17)=-GZ2*ZEP/4.0
      H22(2,18)=-0.5*GZP*EA*ZEP
      H22(2,19)=GZ2*ZEP/4.0
      H22(2,20)=-0.5*GZM*EA*ZEP
      H22(3,1)=-GZM*EAM*(-2.0*ZE-GZ-EA-1.0)/8.0
      H22(3,2)=-GZP*EAM*(-2.0*ZE+GZ-EA-1.0)/8.0
      H22(3,3)=-GZP*EAP*(-2.0*ZE+GZ+EA-1.0)/8.0
      H22(3,4)=-GZM*EAP*(-2.0*ZE-GZ+EA-1.0)/8.0
      H22(3,5)=GZM*EAM*(2.0*ZE-GZ-EA-1.0)/8.0
      H22(3,6)=GZP*EAM*(2.0*ZE+GZ-EA-1.0)/8.0
      H22(3,7)=GZP*EAP*(2.0*ZE+GZ+EA-1.0)/8.0
      H22(3,8)=GZM*EAP*(2.0*ZE-GZ+EA-1.0)/8.0
      H22(3, 9)=-GZ2*EAM/4.0
      H22(3,10)=-GZP*EA2/4.0
      H22(3,11)=-GZ2*EAP/4.0
      H22(3,12)=-GZM*EA2/4.0
      H22(3,13)=-0.5*GZM*EAM*ZE
      H22(3,14)=-0.5*GZP*EAM*ZE
      H22(3,15)=-0.5*GZP*EAP*ZE
      H22(3,16)=-0.5*GZM*EAP*ZE
      H22(3,17)=GZ2*EAM/4.0
      H22(3,18)=GZP*EA2/4.0
      H22(3,19)=GZ2*EAP/4.0
      H22(3,20)=GZM*EA2/4.0
      RETURN
      END
      SUBROUTINE FFF
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/RN22(20),H22(3,20),XYZ(3,20),BMA(6,60),
     1         DF(60),EE(6,6,30),SR(6),XGX(5),EM(500),
     2         STI(8000),PR(500),X1,X2,X3,U1,U2,U3,DET,
     3         GZ,EA,ZE,M,MM,LX,LY,LZ,IDE,IRR
      DIMENSION GJI(3,3),GJ(3,3),GH(3,20)
      DO 500 I=1,3
      DO 500 J=1,3
      GJ(I,J)=0.0
      DO 500 K=1,20
  500 GJ(I,J)=GJ(I,J)+H22(I,K)*XYZ(J,K)
      DET=GJ(1,1)*GJ(2,2)*GJ(3,3)+GJ(1,2)*GJ(2,3)*GJ(3,1)
     1   +GJ(1,3)*GJ(2,1)*GJ(3,2)-GJ(1,3)*GJ(2,2)*GJ(3,1)
     2   -GJ(1,2)*GJ(2,1)*GJ(3,3)-GJ(1,1)*GJ(2,3)*GJ(3,2)
      IF(ABS(DET).GT.1.E-09) GO TO 501
      IDE=4
      RETURN 
  501 GJI(1,1)=( GJ(2,2)*GJ(3,3)-GJ(2,3)*GJ(3,2))/DET
      GJI(2,1)=(-GJ(2,1)*GJ(3,3)+GJ(2,3)*GJ(3,1))/DET
      GJI(3,1)=( GJ(2,1)*GJ(3,2)-GJ(2,2)*GJ(3,1))/DET
      GJI(1,2)=(-GJ(1,2)*GJ(3,3)+GJ(1,3)*GJ(3,2))/DET
      GJI(2,2)=( GJ(1,1)*GJ(3,3)-GJ(1,3)*GJ(3,1))/DET
      GJI(3,2)=(-GJ(1,1)*GJ(3,2)+GJ(1,2)*GJ(3,1))/DET
      GJI(1,3)=( GJ(1,2)*GJ(2,3)-GJ(1,3)*GJ(2,2))/DET
      GJI(2,3)=(-GJ(1,1)*GJ(2,3)+GJ(1,3)*GJ(2,1))/DET
      GJI(3,3)=( GJ(1,1)*GJ(2,2)-GJ(1,2)*GJ(2,1))/DET
      DO 502 I=1,20
      DO 502 J=1,3
      GH(J,I)=0.0
      DO 502 K=1,3
  502 GH(J,I)=GH(J,I)+GJI(J,K)*H22(K,I)
      DO 503 I=1,6
      DO 503 J=1,60
  503 BMA(I,J)=0.0
      DO 504 J=1,20
      BMA(1,3*J-2)=GH(1,J)
      BMA(2,3*J-1)=GH(2,J)
      BMA(3,3*J)  =GH(3,J)
      BMA(4,3*J-2)=GH(2,J)
      BMA(4,3*J-1)=GH(1,J)
      BMA(5,3*J-1)=GH(3,J)
      BMA(5,3*J)  =GH(2,J)
      BMA(6,3*J-2)=GH(3,J)
  504 BMA(6,3*J)  =GH(1,J)
      RETURN
      END
